#ifndef ID_KIND_ASDL_H
#define ID_KIND_ASDL_H

#include <stdint.h>  // uint16_t

class BigStr;

namespace id_kind_asdl {

#define ASDL_NAMES struct
ASDL_NAMES Id {
  enum no_name {
  Word_Compound = 1,
  Arith_Semi = 2,
  Arith_Comma = 3,
  Arith_Plus = 4,
  Arith_Minus = 5,
  Arith_Star = 6,
  Arith_Slash = 7,
  Arith_Percent = 8,
  Arith_DPlus = 9,
  Arith_DMinus = 10,
  Arith_DStar = 11,
  Arith_LParen = 12,
  Arith_RParen = 13,
  Arith_LBracket = 14,
  Arith_RBracket = 15,
  Arith_RBrace = 16,
  Arith_QMark = 17,
  Arith_Colon = 18,
  Arith_LessEqual = 19,
  Arith_Less = 20,
  Arith_GreatEqual = 21,
  Arith_Great = 22,
  Arith_DEqual = 23,
  Arith_NEqual = 24,
  Arith_DAmp = 25,
  Arith_DPipe = 26,
  Arith_Bang = 27,
  Arith_DGreat = 28,
  Arith_DLess = 29,
  Arith_Amp = 30,
  Arith_Pipe = 31,
  Arith_Caret = 32,
  Arith_Tilde = 33,
  Arith_Equal = 34,
  Arith_PlusEqual = 35,
  Arith_MinusEqual = 36,
  Arith_StarEqual = 37,
  Arith_SlashEqual = 38,
  Arith_PercentEqual = 39,
  Arith_DGreatEqual = 40,
  Arith_DLessEqual = 41,
  Arith_AmpEqual = 42,
  Arith_CaretEqual = 43,
  Arith_PipeEqual = 44,
  Eof_Real = 45,
  Eof_RParen = 46,
  Eof_Backtick = 47,
  Undefined_Tok = 48,
  Unknown_Tok = 49,
  Unknown_Backslash = 50,
  Unknown_DEqual = 51,
  Unknown_DAmp = 52,
  Unknown_DPipe = 53,
  Eol_Tok = 54,
  Ignored_LineCont = 55,
  Ignored_Space = 56,
  Ignored_Comment = 57,
  Ignored_Newline = 58,
  WS_Space = 59,
  Lit_Chars = 60,
  Lit_CharsWithoutPrefix = 61,
  Lit_VarLike = 62,
  Lit_ArrayLhsOpen = 63,
  Lit_ArrayLhsClose = 64,
  Lit_Splice = 65,
  Lit_AtLBracket = 66,
  Lit_AtLBraceDot = 67,
  Lit_Other = 68,
  Lit_EscapedChar = 69,
  Lit_LBracket = 70,
  Lit_RBracket = 71,
  Lit_Star = 72,
  Lit_QMark = 73,
  Lit_LBrace = 74,
  Lit_RBrace = 75,
  Lit_Comma = 76,
  Lit_Equals = 77,
  Lit_Dollar = 78,
  Lit_DRightBracket = 79,
  Lit_Tilde = 80,
  Lit_Pound = 81,
  Lit_TPound = 82,
  Lit_TDot = 83,
  Lit_Slash = 84,
  Lit_Percent = 85,
  Lit_Colon = 86,
  Lit_Digits = 87,
  Lit_At = 88,
  Lit_ArithVarLike = 89,
  Lit_BadBackslash = 90,
  Lit_CompDummy = 91,
  Backtick_Right = 92,
  Backtick_Quoted = 93,
  Backtick_DoubleQuote = 94,
  Backtick_Other = 95,
  History_Op = 96,
  History_Num = 97,
  History_Search = 98,
  History_Other = 99,
  Op_Newline = 100,
  Op_Amp = 101,
  Op_Pipe = 102,
  Op_PipeAmp = 103,
  Op_DAmp = 104,
  Op_DPipe = 105,
  Op_Semi = 106,
  Op_DSemi = 107,
  Op_SemiAmp = 108,
  Op_DSemiAmp = 109,
  Op_LParen = 110,
  Op_RParen = 111,
  Op_DLeftParen = 112,
  Op_DRightParen = 113,
  Op_Less = 114,
  Op_Great = 115,
  Op_Bang = 116,
  Op_LBracket = 117,
  Op_RBracket = 118,
  Op_LBrace = 119,
  Op_RBrace = 120,
  Expr_Reserved = 121,
  Expr_Symbol = 122,
  Expr_Name = 123,
  Expr_DecInt = 124,
  Expr_BinInt = 125,
  Expr_OctInt = 126,
  Expr_HexInt = 127,
  Expr_Float = 128,
  Expr_Bang = 129,
  Expr_Dot = 130,
  Expr_DDot = 131,
  Expr_Colon = 132,
  Expr_RArrow = 133,
  Expr_RDArrow = 134,
  Expr_DSlash = 135,
  Expr_TEqual = 136,
  Expr_NotDEqual = 137,
  Expr_TildeDEqual = 138,
  Expr_At = 139,
  Expr_DoubleAt = 140,
  Expr_Ellipsis = 141,
  Expr_Dollar = 142,
  Expr_NotTilde = 143,
  Expr_DTilde = 144,
  Expr_NotDTilde = 145,
  Expr_DStarEqual = 146,
  Expr_DSlashEqual = 147,
  Expr_CastedDummy = 148,
  Expr_Null = 149,
  Expr_True = 150,
  Expr_False = 151,
  Expr_And = 152,
  Expr_Or = 153,
  Expr_Not = 154,
  Expr_For = 155,
  Expr_Is = 156,
  Expr_In = 157,
  Expr_If = 158,
  Expr_Else = 159,
  Expr_Func = 160,
  Expr_Capture = 161,
  Expr_As = 162,
  Char_OneChar = 163,
  Char_Stop = 164,
  Char_Hex = 165,
  Char_YHex = 166,
  Char_Octal3 = 167,
  Char_Octal4 = 168,
  Char_Unicode4 = 169,
  Char_SurrogatePair = 170,
  Char_Unicode8 = 171,
  Char_UBraced = 172,
  Char_Pound = 173,
  Char_AsciiControl = 174,
  BashRegex_LParen = 175,
  BashRegex_AllowedInParens = 176,
  Eggex_Start = 177,
  Eggex_End = 178,
  Eggex_Dot = 179,
  Redir_Less = 180,
  Redir_Great = 181,
  Redir_DLess = 182,
  Redir_TLess = 183,
  Redir_DGreat = 184,
  Redir_GreatAnd = 185,
  Redir_LessAnd = 186,
  Redir_DLessDash = 187,
  Redir_LessGreat = 188,
  Redir_Clobber = 189,
  Redir_AndGreat = 190,
  Redir_AndDGreat = 191,
  Left_DoubleQuote = 192,
  Left_JDoubleQuote = 193,
  Left_SingleQuote = 194,
  Left_DollarSingleQuote = 195,
  Left_RSingleQuote = 196,
  Left_USingleQuote = 197,
  Left_BSingleQuote = 198,
  Left_TDoubleQuote = 199,
  Left_DollarTDoubleQuote = 200,
  Left_TSingleQuote = 201,
  Left_RTSingleQuote = 202,
  Left_UTSingleQuote = 203,
  Left_BTSingleQuote = 204,
  Left_Backtick = 205,
  Left_DollarParen = 206,
  Left_DollarBrace = 207,
  Left_DollarBraceZsh = 208,
  Left_DollarDParen = 209,
  Left_DollarBracket = 210,
  Left_DollarDoubleQuote = 211,
  Left_ProcSubIn = 212,
  Left_ProcSubOut = 213,
  Left_AtParen = 214,
  Left_CaretParen = 215,
  Left_CaretBracket = 216,
  Left_CaretBrace = 217,
  Left_CaretDoubleQuote = 218,
  Left_ColonPipe = 219,
  Left_PercentParen = 220,
  Right_DoubleQuote = 221,
  Right_SingleQuote = 222,
  Right_Backtick = 223,
  Right_DollarBrace = 224,
  Right_DollarDParen = 225,
  Right_DollarDoubleQuote = 226,
  Right_DollarSingleQuote = 227,
  Right_Subshell = 228,
  Right_ShFunction = 229,
  Right_CasePat = 230,
  Right_ShArrayLiteral = 231,
  Right_ExtGlob = 232,
  Right_BashRegexGroup = 233,
  Right_BlockLiteral = 234,
  ExtGlob_Comma = 235,
  ExtGlob_At = 236,
  ExtGlob_Star = 237,
  ExtGlob_Plus = 238,
  ExtGlob_QMark = 239,
  ExtGlob_Bang = 240,
  VSub_DollarName = 241,
  VSub_Name = 242,
  VSub_Number = 243,
  VSub_Bang = 244,
  VSub_At = 245,
  VSub_Pound = 246,
  VSub_Dollar = 247,
  VSub_Star = 248,
  VSub_Hyphen = 249,
  VSub_QMark = 250,
  VSub_Dot = 251,
  VTest_ColonHyphen = 252,
  VTest_Hyphen = 253,
  VTest_ColonEquals = 254,
  VTest_Equals = 255,
  VTest_ColonQMark = 256,
  VTest_QMark = 257,
  VTest_ColonPlus = 258,
  VTest_Plus = 259,
  VOp0_Q = 260,
  VOp0_E = 261,
  VOp0_P = 262,
  VOp0_A = 263,
  VOp0_a = 264,
  VOp1_Percent = 265,
  VOp1_DPercent = 266,
  VOp1_Pound = 267,
  VOp1_DPound = 268,
  VOp1_Caret = 269,
  VOp1_DCaret = 270,
  VOp1_Comma = 271,
  VOp1_DComma = 272,
  VOpYsh_Pipe = 273,
  VOpYsh_Space = 274,
  VOp2_Slash = 275,
  VOp2_Colon = 276,
  VOp2_LBracket = 277,
  VOp2_RBracket = 278,
  VOp3_At = 279,
  VOp3_Star = 280,
  Node_PostDPlus = 281,
  Node_PostDMinus = 282,
  Node_UnaryPlus = 283,
  Node_UnaryMinus = 284,
  Node_NotIn = 285,
  Node_IsNot = 286,
  KW_DLeftBracket = 287,
  KW_Bang = 288,
  KW_For = 289,
  KW_While = 290,
  KW_Until = 291,
  KW_Do = 292,
  KW_Done = 293,
  KW_In = 294,
  KW_Case = 295,
  KW_Esac = 296,
  KW_If = 297,
  KW_Fi = 298,
  KW_Then = 299,
  KW_Else = 300,
  KW_Elif = 301,
  KW_Function = 302,
  KW_Time = 303,
  KW_Const = 304,
  KW_Var = 305,
  KW_SetVar = 306,
  KW_SetGlobal = 307,
  KW_Call = 308,
  KW_Proc = 309,
  KW_Typed = 310,
  KW_Func = 311,
  ControlFlow_Break = 312,
  ControlFlow_Continue = 313,
  ControlFlow_Return = 314,
  ControlFlow_Exit = 315,
  LookAhead_FuncParens = 316,
  Glob_LBracket = 317,
  Glob_RBracket = 318,
  Glob_Star = 319,
  Glob_QMark = 320,
  Glob_Bang = 321,
  Glob_Caret = 322,
  Glob_EscapedChar = 323,
  Glob_BadBackslash = 324,
  Glob_CleanLiterals = 325,
  Glob_OtherLiteral = 326,
  Format_EscapedPercent = 327,
  Format_Percent = 328,
  Format_Flag = 329,
  Format_Num = 330,
  Format_Dot = 331,
  Format_Type = 332,
  Format_Star = 333,
  Format_Time = 334,
  Format_Zero = 335,
  PS_Subst = 336,
  PS_Octal3 = 337,
  PS_LBrace = 338,
  PS_RBrace = 339,
  PS_Literals = 340,
  PS_BadBackslash = 341,
  Range_Int = 342,
  Range_Char = 343,
  Range_Dots = 344,
  Range_Other = 345,
  J8_LBracket = 346,
  J8_RBracket = 347,
  J8_LBrace = 348,
  J8_RBrace = 349,
  J8_Comma = 350,
  J8_Colon = 351,
  J8_Null = 352,
  J8_Bool = 353,
  J8_Int = 354,
  J8_Float = 355,
  J8_String = 356,
  J8_Identifier = 357,
  J8_Newline = 358,
  J8_Tab = 359,
  J8_LParen = 360,
  J8_RParen = 361,
  J8_Operator = 362,
  ShNumber_Dec = 363,
  ShNumber_Hex = 364,
  ShNumber_Oct = 365,
  ShNumber_BaseN = 366,
  BoolUnary_z = 367,
  BoolUnary_n = 368,
  BoolUnary_o = 369,
  BoolUnary_t = 370,
  BoolUnary_v = 371,
  BoolUnary_R = 372,
  BoolUnary_a = 373,
  BoolUnary_b = 374,
  BoolUnary_c = 375,
  BoolUnary_d = 376,
  BoolUnary_e = 377,
  BoolUnary_f = 378,
  BoolUnary_g = 379,
  BoolUnary_h = 380,
  BoolUnary_k = 381,
  BoolUnary_L = 382,
  BoolUnary_p = 383,
  BoolUnary_r = 384,
  BoolUnary_s = 385,
  BoolUnary_S = 386,
  BoolUnary_u = 387,
  BoolUnary_w = 388,
  BoolUnary_x = 389,
  BoolUnary_O = 390,
  BoolUnary_G = 391,
  BoolUnary_N = 392,
  BoolUnary_true = 393,
  BoolUnary_false = 394,
  BoolBinary_GlobEqual = 395,
  BoolBinary_GlobDEqual = 396,
  BoolBinary_GlobNEqual = 397,
  BoolBinary_EqualTilde = 398,
  BoolBinary_ef = 399,
  BoolBinary_nt = 400,
  BoolBinary_ot = 401,
  BoolBinary_eq = 402,
  BoolBinary_ne = 403,
  BoolBinary_gt = 404,
  BoolBinary_ge = 405,
  BoolBinary_lt = 406,
  BoolBinary_le = 407,
  BoolBinary_Equal = 408,
  BoolBinary_DEqual = 409,
  BoolBinary_NEqual = 410,
  ARRAY_SIZE = 411,
  };
};

BigStr* Id_str(int tag, bool dot = true);

typedef uint16_t Id_t;

enum class Kind {
  Word = 1,
  Arith = 2,
  Eof = 3,
  Undefined = 4,
  Unknown = 5,
  Eol = 6,
  Ignored = 7,
  WS = 8,
  Lit = 9,
  Backtick = 10,
  History = 11,
  Op = 12,
  Expr = 13,
  Char = 14,
  BashRegex = 15,
  Eggex = 16,
  Redir = 17,
  Left = 18,
  Right = 19,
  ExtGlob = 20,
  VSub = 21,
  VTest = 22,
  VOp0 = 23,
  VOp1 = 24,
  VOpYsh = 25,
  VOp2 = 26,
  VOp3 = 27,
  Node = 28,
  KW = 29,
  ControlFlow = 30,
  LookAhead = 31,
  Glob = 32,
  Format = 33,
  PS = 34,
  Range = 35,
  J8 = 36,
  ShNumber = 37,
  BoolUnary = 38,
  BoolBinary = 39,
};
typedef Kind Kind_t;

BigStr* Kind_str(Kind tag, bool dot = true);


}  // namespace id_kind_asdl

#endif  // ID_KIND_ASDL_H
